/*****************************************************************************************
 Copyright (c) 2002-2004 The UbixOS Project
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are
 permitted provided that the following conditions are met:

 Redistributions of source code must retain the above copyright notice, this list of
 conditions, the following disclaimer and the list of authors.  Redistributions in binary
 form must reproduce the above copyright notice, this list of conditions, the following
 disclaimer and the list of authors in the documentation and/or other materials provided
 with the distribution. Neither the name of the UbixOS Project nor the names of its
 contributors may be used to endorse or promote products derived from this software
 without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 $Id$

*****************************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/mpi.h>
#include "./include/ubistry.h"

struct ubistryKey *keys = 0x0;

  
int main(int argc,char **argv) {
  mpiMessage_t       msg;
  struct ubistryKey *tmpKey = 0x0;

  if (fork() != 0x0) {
    exit(0x0);
    }

  if (mpiCreateMbox("ubistry") != 0x0) {
    printf("Error: Error Creating Mail Box\n");
    exit(-1);
    }

  keys = (struct ubistryKey *)malloc(sizeof(struct ubistryKey));

  ubistryAddKey("ubu","is a god");
  ubistryAddKey("TCA","is a cry baby");

  while (1) {
    if (mpiFetchMessage("ubistry",&msg) == 0x0) {
      switch (msg.type) {
        case 50:
          tmpKey = ubistryFindKey(msg.data);
          if (tmpKey == 0x0)
            printf("ubistry: Key (%s) Not Found\n",msg.data);
          else
            printf("ubistry: key (%s) Found Has Value (%s)\n",tmpKey->name,tmpKey->value);
          break;
        default:
          printf("ubistry: Command (%i) With Data (%s) Not Valid\n",msg.type,msg.data);
          break;
        }
      }
    }

  exit(0x0);
  }

struct ubistryKey * ubistryFindKey(char *name) {
  struct ubistryKey *tmpKey = keys;

  for (;tmpKey;tmpKey=tmpKey->next) {
    if (!strcmp(name,tmpKey->name)) {
      return(tmpKey);
      }
    }
  return(0x0);
  }

int ubistryAddKey(char *name,char *value) {
  struct ubistryKey *tmpKey = (struct ubistryKey *)malloc(sizeof(struct ubistryKey));

  sprintf(tmpKey->name,name);
  sprintf(tmpKey->value,value);

  if (keys == 0x0) {
    keys = tmpKey;
    keys->prev = 0x0;
    keys->next = 0x0;
    } 
  else {
    tmpKey->next = keys;
    tmpKey->prev = 0x0;
    keys->prev   = tmpKey;
    keys         = tmpKey;
    }

  return(0x0);
  }

/***
 $Log$
 Revision 1.2  2004/05/26 12:16:02  reddawg
 ubistry: now runs as a deamon

 Revision 1.1  2004/05/26 12:09:12  reddawg
 ubistry: this is the frame work for the ubix registry system more to come
          over the next few days

 END
 ***/
